{$ifndef string}
{$define string}

procedure StrCat(Str1, Str2: PChar);
asm
 test edx, edx
 jz @Exit
 push edi
 push ecx
 push esi
 mov edi, eax
 xor ecx, ecx
 xor eax, eax
 not ecx
 repne scasb
 dec edi
 push edi
 mov edi, edx
 repne scasb
 mov ecx, edi
 sub ecx, edx
 mov esi, edx
 pop edi
 rep movsb
 pop esi
 pop ecx
 pop edi
@Exit:
end;

procedure StrCpy(Dest, Src: PChar);
asm
 test edx, edx
 jz @Exit
 push edi
 push esi
 push ecx
 push eax
 mov edi, edx
 xor eax, eax
 xor ecx, ecx
 not ecx
 repne scasb
 sub edi, edx
 mov ecx, edi
 pop edi
 mov esi, edx
 rep movsb
 pop ecx
 pop esi
 pop edi
@Exit:
end;

function StrLen(Str: PChar): cardinal;
asm
 push esi
 push edi
 push ecx
 push eax
 mov edi, eax
 xor eax, eax
 xor ecx, ecx
 not ecx
 repne scasb
 pop eax
 sub edi, eax
 mov eax, edi
 dec eax
 pop ecx
 pop edi
 pop esi
end;


procedure ToHex(Value, Digits: cardinal; OutBuff: PChar);
asm  
 push esi
 push edi
 push ecx
 mov esi, esp
 sub esp, 32
 push ecx
@CvtLoop:
 push edx
 push esi
@D1:
 xor edx, edx
 mov ecx, 16
 div ecx
 dec esi
 add dl, '0'
 cmp dl, '0' + 10
 jb @D2
 add dl, ('A' - '0') - 10
@D2:
 mov [esi], dl
 or eax, eax
 jne @D1
 pop ecx
 pop edx
 sub ecx, esi
 sub edx, ecx
 jbe @D5
 add ecx, edx
 mov al, '0'
 sub esi, edx
 jmp @z
@zloop:
 mov [esi + edx], al
@z:
 dec edx
 jnz @zloop
 mov [esi], al
@D5:
 pop edi
 rep movsb
 xor eax, eax
 mov [edi], al
 add esp, 32
 pop ecx
 pop edi
 pop esi
end;
           
  
procedure UpCase(Str: PChar);
var
 r: cardinal;
begin
  for r := 0 to StrLen(Str) do
   if Str[r] in ['a'..'z'] then Dec(Str[r], Ord('a') - Ord('A'));
end;

procedure Copy(Src, Dst: PChar; Index, Count: cardinal);
asm
 push esi
 push edi
 push ecx
 mov esi, eax
 add esi, ecx
 dec esi
 mov edi, edx
 mov ecx, [ebp+8]
 rep movsb
 xor eax, eax
 stosb
 pop ecx
 pop edi
 pop esi
end;

procedure ZeroMemory(Addr: pointer; Size: cardinal);
asm
 push edi
 push ecx
 mov edi, eax
 mov ecx, edx
 xor eax, eax
 rep stosb
 pop ecx
 pop edi
end;

Procedure AlignText(Buff: PChar; Aligment: byte);
var
 Len, r: dword;
begin
 Len := StrLen(Buff);
 if Len < Aligment then
  begin
   for r := 0 to Aligment - Len do Buff[Len + r] := ' ';
   Buff[Aligment] := #0;
  end;
end;

{$endif}